diff options
author | Jim Meyering <jim@meyering.net> | 2007-08-16 19:18:29 +0200 |
---|---|---|
committer | Jim Meyering <jim@meyering.net> | 2007-08-16 19:18:29 +0200 |
commit | d2e5e366a1d813e5ce2d03e250eb1ebe44473b63 (patch) | |
tree | bead7ed244a8336fa65069cfee3a717a7c044d3e /tests/misc/od | |
parent | e069d38d35b8f50897f6bdc29cc022cd5efa9749 (diff) | |
download | coreutils-d2e5e366a1d813e5ce2d03e250eb1ebe44473b63.tar.xz |
Consolidate od tests.
* tests/misc/od: Perform od-zero-len's test here.
Include boilerplate code, so tests run in a subdirectory.
* tests/misc/od-zero-len: Remove this file.
Diffstat (limited to 'tests/misc/od')
-rwxr-xr-x | tests/misc/od | 38 |
1 files changed, 37 insertions, 1 deletions
diff --git a/tests/misc/od b/tests/misc/od index aba847458..e5d0c59fd 100755 --- a/tests/misc/od +++ b/tests/misc/od @@ -20,6 +20,20 @@ : ${PERL=perl} : ${srcdir=.} +pwd=`pwd` +t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$ +trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0 +trap '(exit $?); exit $?' 1 2 13 15 + +framework_failure=0 +mkdir -p $tmp || framework_failure=1 +cd $tmp || framework_failure=1 + +if test $framework_failure = 1; then + echo "$0: failure in testing framework" 1>&2 + (exit 1); exit 1 +fi + PROG=`echo $0|sed 's,.*/,,'`; export PROG $PERL -e 1 > /dev/null 2>&1 || { @@ -28,7 +42,7 @@ $PERL -e 1 > /dev/null 2>&1 || { exit 77 } -exec $PERL -w -I$srcdir/.. -MCoreutils -- - <<\EOF +exec $PERL -w -I$pwd/.. -MCoreutils -- - <<\EOF require 5.003; use strict; @@ -37,6 +51,23 @@ use strict; # Turn off localisation of executable's ouput. @ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3; +# Use a file in /proc whose size is not likely to +# change between the wc and od invocations. +my $proc_file = '/proc/version'; +-f $proc_file + or $proc_file = '/dev/null'; + +# Count the bytes in $proc_file, _by reading_. +my $len = 0; +open FH, '<', $proc_file + or die "$program_name: can't open `$proc_file' for reading: $!\n"; +while (defined (my $line = <FH>)) + { + $len += length $line; + } +close FH; +my $proc_file_byte_count = $len; + my @Tests = ( # Skip the exact length of the input file. @@ -49,6 +80,11 @@ my @Tests = # Skip the sum of the lengths of the first three inputs, printing the 4th. ['j-bug4', '-c -j 3 -An', {IN=>{g=>'a'}}, {IN=>{h=>'b'}}, {IN=>{i=>'c'}}, {IN=>{j=>'d'}}, {OUT=>" d\n"}], + + # Ensure that od -j doesn't fseek across a nonempty file in /proc, + # even if the kernel reports that the file has stat.st_size = 0. + ['j-proc', "-An -c -j $proc_file_byte_count $proc_file", + {IN=>{f2=>'e'}}, {OUT=>" e\n"}], ); my $save_temps = $ENV{DEBUG}; |